=== debian/changelog ===
criu (3.13-7) unstable; urgency=medium

  * Fix build failure against gcc-10

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 13 Apr 2020 15:15:56 +0200

criu (3.13-6) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 06 Apr 2020 22:49:20 +0200

criu (3.13-5) experimental; urgency=medium

  * [armhf] remove stack pointer from clobber list
  * Declare compliance with Debian policy 4.5.0

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 25 Jan 2020 15:36:05 +0100

criu (3.13-4) experimental; urgency=medium

  * [s390x] remove stack pointer from clobber list

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 17 Jan 2020 06:53:16 +0100

criu (3.13-3) experimental; urgency=medium

  * [ppc64el] remove register '1' from clobber list
  * Update copyright years for debian/* packaging files

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 14 Jan 2020 19:17:15 +0100

criu (3.13-2) experimental; urgency=medium

  * Add Build-Depends on libbsd-dev

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 11 Oct 2019 00:30:06 +0200

criu (3.13-1) experimental; urgency=medium

  * New upstream version 3.13
  * Add Build-Depends on libgnutls28-dev

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 10 Oct 2019 16:39:06 +0200

criu (3.12-1) experimental; urgency=medium

  * New upstream version 3.12
  * Update copyright years for debian/* packaging files
  * Add missing pkg-config to Build-Depends.
    Thanks to Scott Kitterman
  * Update to use python3.
    Build-Depends on python3-all instead of python-all.
    Drop Depends on python-future, python-ipaddr and change Depends on
    python-protobuf to python3-protobuf.
    Replace ${python:Depends} substitution with ${python3:Depends}.
    Pass --with python3 to dh in debian/rules and pass PYTHON="python3" in
    the dh_auto_install override.
    Thanks to Scott Kitterman (Closes: #927104)
  * Declare compliance with Debian policy 4.4.1
  * Update .gitlab-ci.yml based on Salsa CI Team's template

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 10 Oct 2019 06:51:02 +0200
