## criu 3.14

=== debian/changelog ===
criu (3.14-1) unstable; urgency=medium

  * New upstream version 3.14
  * Drop "ppc64le: remove register '1' from clobber list"
  * Drop "s390x: remove stack pointer from clobber list"
  * Drop "arm: remove stack pointer from clobber list"
  * Drop "criu: fix build failure against gcc-10"
  * Bump Debhelper compat level to 13

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 09 May 2020 10:37:52 +0200
