=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends:
  asciidoc,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-python,
  libbsd-dev,
  libcap-dev,
