## criu 3.16

=== debian/changelog ===
criu (3.16-2) unstable; urgency=medium

  * Convert shebang for criu-ns to use python3 (Closes: #994929)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 23 Sep 2021 15:11:46 +0200

criu (3.16-1) unstable; urgency=medium

  * New upstream version 3.16
    - Includes criu-ns script to run criu in different namespaces
      (Closes: #929754)
  * Update copyright years for debian/* packaging files
  * debian/control: Add Build-Depends on libnftables-dev

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 23 Sep 2021 08:53:22 +0200

criu (3.15-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.1, no changes needed.

  [ Salvatore Bonaccorso ]
  * Upload to unstable
  * Declare compliance with Debian policy 4.6.0
  * debian/control: Drop alternative Recommends on iproute

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 23 Sep 2021 08:18:18 +0200

criu (3.15-1) experimental; urgency=medium

  * New upstream version 3.15
  * debian/copyright: Add missing 'the' in references to GPL-2 file
  * debian/copyright: Add license stanza for LGPL-2.1+
  * debian/copyright: Update copyright information for new files

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 16 Nov 2020 17:42:10 +0100
